#! /bin/sh

BINDIR=../../bin

PAREA=4000000	# size of program area
STACK=2000000	# size of control stack and heap
TRAIL=2000000	# size of trail stack
TABLE=1000000	# size of table area

case `uname -m` in
    x86_64)
        PROC=64
        ;;
    *)
        PROC=32
        ;;
esac

case `uname -s` in
    Linux)
        BINARY=$BINDIR/prism_linux${PROC}.bin
        ;;
    Darwin)
        BINARY=$BINDIR/prism_darwin.bin
        ;;
    CYGWIN*)
        BINARY=$BINDIR/prism_cygwin.exe
        ;;
esac

if [ ! -x "$BINARY" ]; then
    echo "`basename $0`: Can't execute \`${BINARY}'." 1>&2
    exit 1
fi

source=`basename $1 .pl`
target=`basename $1 .pl`.out

exec $BINARY -p $PAREA -s $STACK -b $TRAIL -t $TABLE $BINDIR/bp.out -g "set_prolog_flag(redefine_builtin,on),compile($source)"
